#include "Rts.h"  // need this for StgStablePtr

#define Node    1 
#define Share   2 
#define Cycle   3 
#define Thunk   4 
#define Char    5 
#define Int     6 
#define SmallInteger 7 
#define LargeInteger 8 
#define Float   9 
#define Double  10 
#define Function 11 
#define Unknown 12 

/* #define FUNCTION_ENCODER "BuDdHa_F" */
#define FUNCTION_ENCODER "F0"

#define IO_ENCODER "E13"

#define TERMINAL_FILE "/dev/tty"

typedef struct _graphNode GraphNode; 
typedef union  _val Val;
typedef char Tag;

union _val
{
   char         character;
   int          machineInt;
   float        machineFloat;
   char *       descriptor;
   StgStablePtr largeIntegerSPtr;
   double       machineDouble;
};

struct _graphNode
{
   unsigned int unique;          /* unique number for this node */
   Val          val;             /* value at this node */
   Tag          tag;             /* node type  */
   short int    numChildren;     /* the number of children, 16 bits should be plenty */
   GraphNode    **children;      /* children arcs, zero or more */
};

typedef struct _listNode List; 

struct _listNode
{
   unsigned int val;
   List *next;
};

GraphNode *makeGraphNode (int unique, Tag tag, char *descriptor, int numChildren);
void freeGraph (GraphNode *node);
void printGraph (GraphNode *node);

List *cons (int val, List *l);
List *freeListNode (List *l);
